

module.exports = {

    getAllActivityGroup: async function (req, res) {
        let data = await Activitygroup.find().sort('id DESC');
        if(data){
            res.ok(data);
        }
        else{
            return res.status(500).send({
                success: false,
                message: "Registros não encontrados."
            });
        }
    },

    createActivityGroup: async function (req, res) {
        let params = req.allParams();
		
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}
		
		let data = await Activitygroup.create(params).fetch();

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "Ocorreu um erro durante o cadastro"
            });
        }
    },

    updateActivityGroup: async function (req, res) {

        let params = req.allParams();

        //Não foi enviado parâmetro
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}else if(!params.id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var data = await Activitygroup.updateOne({ "id": params.id }).set(params);

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "ID informado, não foi encontrado"
            });
        }
    },

    deleteActivityGroupById: async function (req, res) {
        var id = req.param('id');
        //Não foi enviado parâmetro
		if(!id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var activities = await Activity.find({idActivityGroup:id});
        if(activities.length > 0){
            return res.ok({
                success: false,
                message: "Existem atividades associadas a esse grupo.",
            });
        }else{
            var data = await Activitygroup.destroyOne({id: id,}, function (err, success) {
                if (err) {             
                    return res.status(500).send({
                        success: false,
                        message: "Não foi excluir este grupo.",
                        err: err
                    });
                } else {
                    return res.ok({
                        success: true,
                    });
                }
            });
        }
    }
};