var passport = require('passport');
var jwt = require('jsonwebtoken');
var passportService = require('../services/passport')
var permissionService = require('../services/permission-validate')
var bcrypt = require('bcrypt-nodejs');
var request = require("request");

async function _onPassportAuth(req, res, error, user, info) {
    //Adicionar o log de acesso
    if (!user) {
        return res.ok(false);
    }

    //var log = await AccessLog.create({ idUser: user.id, email: user.email, path: req.path, method: req.method }).fetch();
    //sails.log(user)


    if (error) return res.serverError(error);
    if (!user) return res.unauthorized(null, info && info.code, info && info.message);

    let listPermissions = await permissionService.getListPermissionByUser(user);


    let type = await Role.findOne({id: user.idRole});

    if(type){
        if (type.isAdmin != null) {
            user.class = 'admin';
        } else if (type.isRegionalManager != null) {
            user.class = 'regionalmanager';
        } else if (type.isTeamManager != null) {
            user.class = 'teammanager';
        } else if (type.isSalesman != null) {
            user.class = 'salesman';
        } else {
            user.class = 'gcd';
        }
    }

    return res.ok({
        token: passportService.createToken(user,listPermissions),
        type: user.class
    });
}

_password = function () {
    this.generate = function (chars) {
        for (var i = 0; i < chars; i++) {
            this.pass += this.getRandomChar();
        }
        return this.pass;
    }

    this.getRandomChar = function () {
        /*
       *    matriz contendo em cada linha indices (inicial e final) da tabela ASCII para retornar alguns caracteres.
       *    [48, 57] = numeros;
       *    [64, 90] = "@" mais letras maiusculas;
       *    [97, 122] = letras minusculas;
       */
        var ascii = [[48, 57], [64, 90], [97, 122]];
        var i = Math.floor(Math.random() * ascii.length);
        return String.fromCharCode(Math.floor(Math.random() * (ascii[i][1] - ascii[i][0])) + ascii[i][0]);
    }

    this.pass = "";
    let chars = 10;
    return this.generate(chars);
}

module.exports = {

    register: function (req, res) {
        // Verificar se o usuário já está cadastrado
        User.getDatastore().sendNativeQuery(`SELECT email FROM user WHERE email = '${req.param('email')}' LIMIT 1`, async function (err, rawResult) {
            if (err) {
                return res.serverError(err);
            }
            // sails.log('total ' + rawResult.rows.length);

            if (rawResult.rows.length === 0) {
                var createdUser = await User
                    .create(_.omit(req.allParams(), 'id'))
                    .then(function (user) {

                        return
                        // TODO: replace with new type of cipher service
                        {
                            token: passportService.createToken(user)
                        }
                    })
                    .then(res.created)
                    .catch(res.serverError);

                //sails.log(createdUser)
                //await AccessLog.create({ idUser: 0, email: req.allParams().email, path: req.path, method: req.method }).fetch();

            } else {
                return res.serverError('Esse nome de usuário já está sendo usado!<br><br> Crie outro!');
            }

            // return res.json(rawResult.rows);
        })


    },


    login: function (req, res) {
        passport.authenticate('local', _onPassportAuth.bind(this, req, res))(req, res);
    },

    logout: function (req, res) {
        req.logout();
        res.send({
            message: "Usuário desconectado.",
            status: "success"
        });
    },

    changePass: function (req, res) {
        // console.log('Passou pelo ChangePass no AuthController');

        var data = req.allParams();
        // console.log(data);
        //Gerar nova senha com 10 dígitos, métodos no início do código
        var senha = _password();

        //Gerar senha hash, utiliza o mesmo código do passaport
        var salt = bcrypt.genSaltSync(10);
        var hash = bcrypt.hashSync(senha, salt);

        // sails.log('Nova Senha: '+senha);
        // sails.log('Nova senha Hash: '+hash);

        //Atualiza a nova senha no banco de dados
        User.getDatastore().sendNativeQuery(`UPDATE user SET password='${hash}' WHERE email='${data.email}'`, function (err, rawResult) {
            if (err) {
                return res.serverError(err);
            }
            //sails.log(rawResult);

            //Se realizou a alteração da senha, terá retorno affectedRows > 0
            if (rawResult.affectedRows > 0) {
                // ------------------ CARREGAR DADOS USUARIO
                // Responsável por carregar o email do usuário alterado
                User.getDatastore().sendNativeQuery(`SELECT email FROM user WHERE email = '${data.email}' LIMIT 1`, function (err, rawResult) {
                    if (err) {
                        return res.serverError(err);
                    }
                    //Se conseguiu encontrar o usuário, irá retornar rawResult.rows.length>0
                    if (rawResult.rows.length > 0) {
                        // Irá Montar o email mask para retornar na função, deste modo não disponibiliza no APP o email completo do usuário
                        let emailArray = rawResult.rows[0].email.split("@");
                        let email = rawResult.rows[0].email[0] + '...@' + emailArray[1];

                        //Disparar email para o usuário
                        request.get("http://localhost/Mail/send.php?user=" + data.email + "&email=" + rawResult.rows[0].email + "&p=" + senha + "&token=" + hash + "&send=send", function (error, response, body) {
                            if (error) {
                                //sails.log('error');
                                // sails.log(error);
                            } else {
                                // sails.log('response');
                                // sails.log(response);
                            }
                        });

                        return res.json({
                            success: true,
                        });
                    } else {
                        return res.json({
                            success: false,
                        });
                    }
                })


                // --- FIM CARREGAR DADOS USUARIO
            } else {
                return res.json({
                    success: false,
                });
            }


        })

    },

};