/**
* Permission.js
*
* @description :: permission controller imported from localhost MySql server at 18/3/2020 16:24:20.
* @docs        :: http://sailsjs.org/#!documentation/controllers
* @routes      :: /* Permission /*
*              'get /permission/getAllPermission/': 'PermissionController.getAllPermission',
*              'get /permission/getPermissionById/:id/': 'PermissionController.getPermissionById',
*              'post /permission/createPermission/': 'PermissionController.createPermission', 
*              'put /permission/updatePermission/': 'PermissionController.updatePermission', 
*              'detele /permission/deletePermissionById/:id/': 'PermissionController.deletePermissionById',
* 
*/


module.exports = {

    
    getAllPermission: async function (req, res) {
            let data = await Permission.find();
            return res.ok(data);
    },


    
    getPermissionById: async function (req, res) {
        var id = req.param('id');
      
        //Não foi enviado parâmetro
		if(!id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        let data = await Permission.find({ id: id });
        return res.ok(data);
       
    },



    createPermission: async function (req, res) {
        let params = req.allParams();
		
		//Não foi enviado parâmetro
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}
		
		let data = await Permission.create(params).fetch();

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "Ocorreu um erro durante o cadastro"
            });
        }
    },


    
    updatePermission: async function (req, res) {

        let params = req.allParams();

        //Não foi enviado parâmetro
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}else if(!params.id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var data = await Permission.updateOne({ "id": params.id }).set(params);

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "ID informado, não foi encontrado"
            });
        }
    },


    
    deletePermissionById: async function (req, res) {
        var id = req.param('id');

        //Não foi enviado parâmetro
		if(!id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var data = await Permission.destroyOne({
            id: id,
        }, function (err, success) {

            if (err) {             
                return res.status(500).send({
                    success: false,
                    message: "Não foi possível deletar",
                    err: err
                });
            } else {
                return res.ok({
                            success: true,
                        });
            }
        });
    }};
