/**
* Rolepermission.js
*
* @description :: rolepermission controller imported from localhost MySql server at 18/3/2020 16:24:20.
* @docs        :: http://sailsjs.org/#!documentation/controllers
* @routes      :: /* Rolepermission /*
*              'get /rolepermission/getAllRolepermission/': 'RolepermissionController.getAllRolepermission',
*              'get /rolepermission/getRolepermissionById/:id/': 'RolepermissionController.getRolepermissionById',
*              'post /rolepermission/createRolepermission/': 'RolepermissionController.createRolepermission', 
*              'put /rolepermission/updateRolepermission/': 'RolepermissionController.updateRolepermission', 
*              'detele /rolepermission/deleteRolepermissionById/:id/': 'RolepermissionController.deleteRolepermissionById',
* 
*/


module.exports = {

    
    getAllRolepermission: async function (req, res) {
            let data = await Rolepermission.find();
            return res.ok(data);
    },


    
    getRolepermissionById: async function (req, res) {
        var id = req.param('id');
      
        //Não foi enviado parâmetro
		if(!id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        let data = await Rolepermission.find({ id: id });
        return res.ok(data);
       
    },



    createRolepermission: async function (req, res) {
        let params = req.allParams();
		
		//Não foi enviado parâmetro
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}
		
		let data = await Rolepermission.create(params).fetch();

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "Ocorreu um erro durante o cadastro"
            });
        }
    },


    
    updateRolepermission: async function (req, res) {

        let params = req.allParams();

        //Não foi enviado parâmetro
		if(Object.keys(params).length == 0){
			return res.status(500).send({
                    success: false,
                    message: "Não foi enviado parâmetros"
                });
		}else if(!params.id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var data = await Rolepermission.updateOne({ "id": params.id }).set(params);

        if (data) {
            return res.ok({
                success: true,
            });
        } else {
            return res.status(500).send({
                success: false,
                message: "ID informado, não foi encontrado"
            });
        }
    },


    
    deleteRolepermissionById: async function (req, res) {
        var id = req.param('id');

        //Não foi enviado parâmetro
		if(!id){
            return res.status(500).send({
                success: false,
                message: "O id não foi enviado"
            });
        }

        var data = await Rolepermission.destroyOne({
            id: id,
        }, function (err, success) {

            if (err) {             
                return res.status(500).send({
                    success: false,
                    message: "Não foi possível deletar",
                    err: err
                });
            } else {
                return res.ok({
                            success: true,
                        });
            }
        });
    }};
