/**
* User.js
*
* @description :: user model imported from localhost MySql server at 18/3/2020 13:54:26.
* @docs        :: http://sailsjs.org/#!documentation/models
*/

bcrypt = require('bcrypt-nodejs');

module.exports = {

  attributes: {
    email : {
      type: 'string'
    },
    password : {
      type: 'string'
    },
    name : {
      type: 'string',
      allowNull: true
    },
    idRole : {
      model: 'role'
    },
    idParent : {
      model: 'user'
    },
    idTeam : {
      model: 'team'
    },
    profileImage : {
      type: 'string',
      allowNull: true
    }
  },
  customToJSON: function () {
    return _.omit(this, ['password'])
  },
  beforeCreate: function (user, cb) {
    bcrypt.genSalt(10, function (err, salt) {
      bcrypt.hash(user.password, salt, null, function (err, hash) {
        if (err) return cb(err);
        user.password = hash;
        return cb();
      })
    })
  },
  beforeUpdate: function (user, cb) {
    if ('password' in user) {

      bcrypt.genSalt(10, function (err, salt) {
        bcrypt.hash(user.password, salt, null, function (err, hash) {
          if (err) return cb(err);
          user.password = hash;
          return cb();
        })
      })
    } else {
      return cb();
    }

  }
};
