/**
 * Route Mappings
 * (sails.config.routes)
 *
 * Your routes tell Sails what to do each time it receives a request.
 *
 * For more information on configuring custom routes, check out:
 * https://sailsjs.com/anatomy/config/routes-js
 */

module.exports.routes = {


    //  ╦ ╦╔═╗╔╗ ╔═╗╔═╗╔═╗╔═╗╔═╗
    //  ║║║║╣ ╠╩╗╠═╝╠═╣║ ╦║╣ ╚═╗
    //  ╚╩╝╚═╝╚═╝╩  ╩ ╩╚═╝╚═╝╚═╝

    /***************************************************************************
     *                                                                          *
     * Make the view located at `views/homepage.ejs` your home page.            *
     *                                                                          *
     * (Alternatively, remove this and add an `index.html` file in your         *
     * `assets` directory)                                                      *
     *                                                                          *
     ***************************************************************************/




    /* Activity */
    'post /activities/createActivity': 'ActivityController.createActivity',
    'delete /activities/deleteActivityById/:id': 'ActivityController.deleteActivityById',
    'get /activities/getAllActivity/': 'ActivityController.getAllActivity',
    'get /activities/getNextActivities/': 'ActivityController.getNextActivities',
    'get /activities/getSalesmanActivities/': 'ActivityController.getSalesmanActivities',
    'get /activities/getActivityById/:id': 'ActivityController.getActivityById',
    'get /activities/getAllActivitiesByTeamManager/:time': 'ActivityController.getAllActivitiesByTeamManager',
    'get /activities/getAllActivitiesByRegionalManager/:time': 'ActivityController.getAllActivitiesByRegionalManager',
    'put /activities/updateActivity': 'ActivityController.updateActivity',
    'get /activities/getAllActivitiesByTeam/:time': 'ActivityController.getAllActivitiesByTeam',


	/* Activityuser */
   'get /assignActivity/getAllActivityuser/': 'ActivityuserController.getAllActivityuser',
   'get /assignActivity/getActivityuserById/:id/': 'ActivityuserController.getActivityuserById',
   'get /assignActivity/getActivityUserByUserId/:id/': 'ActivityuserController.getActivityUserByUserId',
   'post /assignActivity/createActivityuser/': 'ActivityuserController.createActivityuser', 
   'put /assignActivity/updateActivityuser/': 'ActivityuserController.updateActivityuser', 
   'delete /assignActivity/deleteActivityUserById/:id/': 'ActivityuserController.deleteActivityUserById',

   /* Activitygroup */
   'get /activitygroup/getAllActivityGroup/': 'ActivitygroupController.getAllActivityGroup',
   'post /activitygroup/createActivityGroup': 'ActivitygroupController.createActivityGroup',
   'put /activitygroup/updateActivityGroup': 'ActivitygroupController.updateActivityGroup',
   'delete /activitygroup/deleteActivityGroupById/:id': 'ActivitygroupController.deleteActivityGroupById',

   /* Award */
   'get /award/getAllAward/': 'AwardController.getAllAward',
   'put /award/updateAward': 'AwardController.updateAward',

	/* Permission */
    'get /permission/getAllPermission/': 'PermissionController.getAllPermission',
    'get /permission/getPermissionById/:id/': 'PermissionController.getPermissionById',
    'post /permission/createPermission/': 'PermissionController.createPermission', 
    'put /permission/updatePermission/': 'PermissionController.updatePermission', 
    'delete /permission/deletePermissionById/:id/': 'PermissionController.deletePermissionById',

	
	/* Role */
    'get /role/getAllRole/': 'RoleController.getAllRole',
    'get /role/getRoleById/:id/': 'RoleController.getRoleById',
    'post /role/createRole/': 'RoleController.createRole', 
    'put /role/updateRole/': 'RoleController.updateRole', 
    'delete /role/deleteRoleById/:id/': 'RoleController.deleteRoleById',

	
	/* Rolepermission */
    'get /rolepermission/getAllRolepermission/': 'RolepermissionController.getAllRolepermission',
    'get /rolepermission/getRolepermissionById/:id/': 'RolepermissionController.getRolepermissionById',
    'post /rolepermission/createRolepermission/': 'RolepermissionController.createRolepermission', 
    'put /rolepermission/updateRolepermission/': 'RolepermissionController.updateRolepermission', 
    'delete /rolepermission/deleteRolepermissionById/:id/': 'RolepermissionController.deleteRolepermissionById',



	/* Sale */
    'get /sales/getAllSales/': 'SaleController.getAllSales',
    'get /sales/getSaleById/:id/': 'SaleController.getSaleById',
    'post /sales/createSale/': 'SaleController.createSale', 
    'put /sales/updateSale/': 'SaleController.updateSale', 
    'delete /sales/deleteSaleById/:id/': 'SaleController.deleteSaleById',
    'get /sales/getAllSalesByTeamManager/:time': 'SaleController.getAllSalesByTeamManager',
    'get /sales/getAllSalesByRegionalManager/:time': 'SaleController.getAllSalesByRegionalManager',
    'get /sales/getAllSalesByTeam/:time': 'SaleController.getAllSalesByTeam',
    



	/* Saleuser */
    'get /assignSales/getAllSaleuser/': 'SaleuserController.getAllSaleuser',
    'get /assignSales/getOpenSaleuser/': 'SaleuserController.getOpenSaleuser',
    'get /assignSales/getSaleuserById/:id/': 'SaleuserController.getSaleuserById',
    'post /assignSales/createSaleuser/': 'SaleuserController.createSaleuser', 
    'put /assignSales/updateSaleuser/': 'SaleuserController.updateSaleuser', 
    'delete /assignSales/deleteSaleUserById/:id/': 'SaleuserController.deleteSaleUserById',
    'get /assignSales/getSalesmanSales/': 'SaleuserController.getSalesmanSales',


	/* Sessions */
    'get /sessions/getAllSessions/': 'SessionsController.getAllSessions',
    'get /sessions/getSessionsById/:id/': 'SessionsController.getSessionsById',
    'post /sessions/createSessions/': 'SessionsController.createSessions', 
    'put /sessions/updateSessions/': 'SessionsController.updateSessions', 
    'detele /sessions/deleteSessionsById/:id/': 'SessionsController.deleteSessionsById',


    /* Team */
    'get /teams/getAllTeams/': 'TeamController.getAllTeams',
    'get /teams/getTeamById/:id/': 'TeamController.getTeamById',
    'post /teams/createTeam/': 'TeamController.createTeam', 
    'put /teams/updateTeam/': 'TeamController.updateTeam', 
    'DELETE /teams/deleteTeamById/:id/': 'TeamController.deleteTeamById',
    'get /teams/getSalesmenGoal/:time': 'TeamController.getSalesmenGoal',
    'get /teams/getSalesmenRanking/': 'TeamController.getSalesmenRanking',
    'get /teams/getSalesmenSoloGoal/': 'TeamController.getSalesmenSoloGoal',
    'get /teams/getTeamManagerGoal/:time': 'TeamController.getTeamManagerGoal',
    'get /teams/getRegionalManagerGoal/:time': 'TeamController.getRegionalManagerGoal',

    /* User */
    'get /user/getUsersByTeamId/:id/': 'UserController.getUsersByTeamId',
    'get /user/getUsersByIdParent/:id/': 'UserController.getUsersByIdParent',
    'get /user/getAllSalesmen/': 'UserController.getAllSalesmen',
    'get /user/getAllRegionalManagers/': 'UserController.getAllRegionalManagers',
    'get /user/getAllTeamManagers/': 'UserController.getAllTeamManagers',
    'post /user/createRegionalManager/': 'UserController.createRegionalManager', 
    'post /user/createTeamManager/': 'UserController.createTeamManager', 
    'post /user/createSalesman/': 'UserController.createSalesman', 
    'put /user/updateRegionalManager/': 'UserController.updateRegionalManager', 
    'put /user/updateTeamManager/': 'UserController.updateTeamManager', 
    'put /user/updateSalesman/': 'UserController.updateSalesman', 
    'put /user/changePassByUser/': 'UserController.changePassByUser',
    'delete /user/deleteManager/:id/': 'UserController.deleteManager',
    'delete /user/deleteSalesman/:id/': 'UserController.deleteSalesman',
    'POST /user/uploadAvatar/': 'UserController.uploadAvatar',
    'get /user/userInfo/': 'UserController.userInfo',
    
    

    
    
    

    /***************************************************************************
     *                                                                          *
     * More custom routes here...                                               *
     * (See https://sailsjs.com/config/routes for examples.)                    *
     *                                                                          *
     * If a request to a URL doesn't match any of the routes in this file, it   *
     * is matched against "shadow routes" (e.g. blueprint routes).  If it does  *
     * not match any of those, it is matched against static assets.             *
     *                                                                          *
     ***************************************************************************/


    //  ╔═╗╔═╗╦  ╔═╗╔╗╔╔╦╗╔═╗╔═╗╦╔╗╔╔╦╗╔═╗
    //  ╠═╣╠═╝║  ║╣ ║║║ ║║╠═╝║ ║║║║║ ║ ╚═╗
    //  ╩ ╩╩  ╩  ╚═╝╝╚╝═╩╝╩  ╚═╝╩╝╚╝ ╩ ╚═╝

    'post /login': 'AuthController.login',
    //'post /register': 'AuthController.register',
    'post /changepass/:username': 'AuthController.changePass',
    '/logout': 'AuthController.logout'


    //  ╦ ╦╔═╗╔╗ ╦ ╦╔═╗╔═╗╦╔═╔═╗
    //  ║║║║╣ ╠╩╗╠═╣║ ║║ ║╠╩╗╚═╗
    //  ╚╩╝╚═╝╚═╝╩ ╩╚═╝╚═╝╩ ╩╚═╝


    //  ╔╦╗╦╔═╗╔═╗
    //  ║║║║╚═╗║
    //  ╩ ╩╩╚═╝╚═╝


};